import ddf.minim.*;
import ddf.minim.signals.*;
import ddf.minim.analysis.*;
 
AudioOutput sound;
FFT fft;
MuzikMaker muzik;
PImage file;
int[][] pixel;
float[] redC, greenC, blueC;  
int x = 0;
 
void setup()
{
  size(600, 513);
   
  file = loadImage("nanobomb.jpg");
  file.loadPixels();
  pixel = new int[width][height];
  for(int i=0; i<width; i++) {
    for(int j=0; j<height; j++) {
 pixel[i][j] = file.pixels[i + width*j];
    }
  }
  redC = new float[height];
  greenC = new float[height];
  blueC = new float[height];
   Minim.start(this);
   sound = Minim.getLineOut(Minim.STEREO, 1024);
   fft = new FFT(1024, 44100);
   muzik = new MuzikMaker();
   
  sound.addSignal(muzik);
  frameRate(5);
}
 
void draw()  
{
  image(file, 0, 0);
  for(int i = 0; i<height; i++){
    redC[i] = red(pixel[x][i]);
    greenC[i] = green(pixel[x][i]);
    blueC[i] = blue(pixel[x][i]);
    //println(redC[i]);
  }
  if (x<width) x++;
  else x = 0;
   
}
 
class MuzikMaker implements AudioSignal
{
   
  void generate(float[] samp)
  {
    for(int i = 0; i < fft.specSize(); i++)
    {
 fft.setBand(i, redC[i]);
 //println(i);
    }
    fft.inverse(samp);  
    //println("inversed");
  }
   
  // this is a stricly mono signal
  void generate(float[] left, float[] right)
  {
    generate(left);
    generate(right);
  }
}
 
 
void stop()
{
  sound.close();
  Minim.stop();
  super.stop();
} 
